#!/bin/sh
# $Id: common.sh,v 1.5 2012/11/28 18:44:07 ca Exp $
#
# Copyright (c) 2011 Claus Assmann
#
# By using this file, you agree to the terms and conditions set
# forth in the license/LICENSE.3C file which can be found at the
# top level of this source code distribution.
#
# ----------------------------------------
# get executables, define some common macros and functions
# ----------------------------------------

A=/usr/bin/nawk
if [ -x $A ]
then
  awk() { $A "$@"; }
fi
G=/usr/xpg4/bin/grep
if [ -x $G ]
then
  grep() { $G "$@"; }
fi

# hack...
PGREP=/usr/bin/pgrep
[ -x $PGREP ] || PGREP=true

chkcto()
{
  PRG=$1
  CTO=$2
  shift 2

  ../$PRG/$PRG -VVV | grep "$CTO" >/dev/null && return 0
  echo "SKIPPED: $0: $PRG not compiled with $CTO $@"
  return 1
}


# relies on global variable PRG
conftest()
{
  EEC=$1

  $PRG -f ${CONF} -VVVV >${OUT} 2>&1
  EC=$?
  if [ ${EC} -ne ${EEC} ]
  then
    echo "$0: ${TEST} exit code=${EC}, expected=${EEC}"
    ERR=1
    return 1
  fi
  return 0
}
