#!/bin/sh
# $Id: t-ocr-1.sh,v 1.4 2011/05/20 20:24:42 ca Exp $
#
# ----------------------------------------
# test outgoing connection rate restrictions per RCPT domain
# ----------------------------------------
#

if test "X"${MTA_TIMING} = "X"
then
  echo "SKIPPED: $0: MTA_TIMING is not set"
  exit 0
fi

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../chkmts
fi
. ${SD}/common.sh

if test X"`uname`" != "XOSF1"
then
while getopts s:V FLAG
do
  case "${FLAG}" in
    s) SKIP="${SKIP} ${OPTARG}";;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

# cd to right directory (where the programs will be executed).
cd ../qmgr || exit 1

chkcto qmgr OCC_RATE
chkcto qmgr COMMERCIAL

# create directory to pass socket
test -d smtps || mkdir smtps

killit()
{
rm -f ${QMGRCONFMAP} ${MTMAP}
exit 1
}

rm -f ${QMGRCONFMAP} ${MTMAP}
trap killit 2

# ----------------------------------------
${CAT} >${SMXCNF} <<EOF
smtps { log_level = 14; pass_fd_socket = smtps/smtpsfd; wait_for_server=4;
    listen_socket { type=inet; port=${SRVPORT}; }
    start_action = pass; user = ${USER};
    path = ../smtps/smtps;
    arguments = "smtps -f ${SMXCNF} ${MTA_SERVER_OPTIONS}";
}
smtpc { log_level = 14; remote_port = ${SNKPORT}; wait_for_server=4;
    connect_only_to = 127.0.0.1;
    io_timeout=60s;
    start_action = wait; user = ${USER};
    path = "../smtpc/smtpc"; arguments = "smtpc -f ${SMXCNF}";
}
qmgr { log_level = 14; wait_for_server=4; wait_for_client=4; 
    retry_delay_min = 30;
    start_action = wait; user = ${USER};
    smtpc {
      connection_limits cl {
        message_rate_max = 5;
      }
    }
    # restart_dependencies = { smtps,smtpc,smar, };
    path = "../qmgr/qmgr"; arguments = "qmgr -f ${SMXCNF} -d 2";
}
smar { log_level = 14;
    start_action = wait; user = ${USER};
    # restart_dependencies = { smtps,qmgr };
    path = "../smar/smar"; arguments = "smar -f ${SMXCNF}";
}
EOF

${CAT} > ${MT} <<EOF
b.c	[10.2.1.1]
dom1.tld	[10.1.1.1]
EOF

clearlogs

${CAT} > ${QMGRCONF} <<EOF
smtpc_conf_rcpt_domain:dom1.tld	connection_limits=cl;
EOF
rm -f ${QMGRCONFMAP}
${MM} -t'	' -F ${QMGRCONFMAP} < ${QMGRCONF}

# ----------------------------------------
# 
TEST=1
if echo "${SKIP} X" | ${GREP} -v " ${TEST} " > /dev/null
then
ERR=false
# 
Nmsgs=20
if ${SHELL} ${SD}/mcpmts.sh -s 70 -A $Nmsgs -E 11 -T $Nmsgs -t 2 -Zsmtpc2 -c "-m $Nmsgs" -R"r@dom1.tld"
then
  :
else
  ERR=true
fi
if ${ERR}
then
  ERRS=`expr ${ERRS} + 1 `
  echo "$0: test ${TEST} failed"
  test X"${MTA_STOPONERROR}" != X && exit 1
else
  ${VERBOSE} && echo "test ${TEST} succeeded"
fi
fi

rm -f ${QMGRCONFMAP} f ${MTMAP}

# ----------------------------------------
# end
if test ${ERRS} -eq 0
then
  exit 0
else
  echo "$0: ${ERRS} error(s)"
  exit 1
fi
