#!/bin/sh
# $Id: t-restart-dep-3.sh,v 1.7 2013/12/22 15:38:17 ca Exp $
#
# Copyright (c) 2011 Claus Assmann
#
# By using this file, you agree to the terms and conditions set
# forth in the license/LICENSE.3C file which can be found at the
# top level of this source code distribution.
#
# ----------------------------------------
# test restart functionality of mcp:
# don't restart anything because "server" failed fatally (too often).
# ----------------------------------------

SD=`dirname $0`
if test "${SD}" = "."
then
   SD=../mcp
fi
L1=smtps.log
L2=qmgr.log
L3=smtpc.log
FILE=exists
. ${SD}/common.sh

rm -f ${FILE} ${PIDS} ${OUT} *core*
rm -f ${PIDF1} ${PIDF2} ${PIDF3} ${L1} ${L2} ${L3}
for i in smtps smtpc qmgr
do
  rm -f $i
  ln -s ${PRG} $i
done

N=10
cat > ${CONF} <<EOF
smtps {
	start_action = wait; processes_min = 1; processes_max = 1;
	user = ${USER};
	path = ./smtps;
	arguments = "smtps -p ${PIDF1} -f ${R1} -n ${N} -VV -s 4 -S ${FILE}";
}
smtpc {
	start_action = wait; processes_min = 1; processes_max = 1;
	user = ${USER};
	path = ./smtpc;
	arguments = "smtpc -p ${PIDF3} -f ${R3} -n ${N} -VV -s 4 -S ${FILE}";
}
qmgr {
	start_action = wait; processes_min = 1; processes_max = 1;
	user = ${USER};
	path = ./qmgr;
	restart_dependencies = {smtps, smtpc};
	arguments = "qmgr -p ${PIDF2} -f ${R2} -n 5 -VV -s 1 -W";
}
EOF

echo 0 > ${R1}
echo 0 > ${R2}
echo 0 > ${R3}
./mcp -D -t -dddd ${CONF} > ${OUT} 2>&1 &
echo $! >> ${PIDS}

# give it time to start
sleep 12

# check that programs behaved properly
# if grep 'service=qmgr, status=' ${OUT} >/dev/null
# then
#   :
# else
#   echo "$0: ERROR: missing in ${OUT}"
#   ERRS=`expr ${ERRS} + 1 `
# fi
chkr ${R1} 4
chkr ${R3} 4
chkr ${R2} 4


stopit
rm -f ${FILE} *core*
testend
